//+------------------------------------------------------------------+
//|                                              MarketDriver_02.mqh |
//|                                 (c) 2010.03.22, Vladimir Gomonov |
//|                                            MetaDriver@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "(c) 2011, Vladimir Gomonov"
#property link      "MetaDriver@rambler.ru"
#include <MyExperts\Global.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Trade\Trade.mqh>
#include <Trade\AccountInfo.mqh>

CAccountInfo AccInfo;
CPositionInfo PosInfo;
CSymbolInfo SymInfo;
CTrade Trade;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CMarketDriver
  {
private:
   double            NolrmalizeLots(double lot);
   //      
   double            TranslateLots(double);
   //      
public:
   double            GetCurrentPos(string Sym);
   //       
   bool              Synhronize(const SymbolPos  &sp[],int  &Err);
   //         
   //   sp      ( )
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool CMarketDriver::Synhronize(const SymbolPos  &sp[],int  &Err)
  {
   Err=0;
   bool res=true;
   for(int i=ArraySize(sp)-1; i>=0; i--)
     {
      SymInfo.Name(sp[i].Sym);
      SymInfo.Refresh();
      double fp= TranslateLots(sp[i].Pos);
      double cp=GetCurrentPos(sp[i].Sym);
      //    if (cp==DBL_MIN) cp=0;
      double pos=fp-cp;
      if(pos>0.000001)
         res=Trade.Buy(NolrmalizeLots(pos),sp[i].Sym);
      if(pos<-0.000001)
         res=Trade.Sell(NolrmalizeLots(pos),sp[i].Sym);
     }
   return res;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CMarketDriver::GetCurrentPos(string Sym)
  {
   if(!PosInfo.Select(Sym)) return 0; // DBL_MIN;
   double v=PosInfo.Volume();
   return(PosInfo.PositionType()==POSITION_TYPE_SELL) ? -v : v;
  }
//+------------------------------------------------------------------+
//| NolrmalizeLots()         |
//+------------------------------------------------------------------+
double CMarketDriver::NolrmalizeLots(double lot)
  {
   lot=MathAbs(lot);
   double MinLot=SymInfo.LotsMin();
   double MaxLot=SymInfo.LotsMax();
   double StepLot=SymInfo.LotsStep();
   if(lot<MinLot)
     {
      if(lot>MinLot/2) lot=MinLot;
      else lot=0;
     }
   else lot=MathRound(lot/StepLot)*StepLot;
   return ((lot<MaxLot)?lot:MaxLot);
  }
//+------------------------------------------------------------------+
double CMarketDriver::TranslateLots(double in)
  {
   double LotMargin=0;
   SymInfo.RefreshRates();
   if(in>0.000001)
     {
      if(!OrderCalcMargin(
         ORDER_TYPE_BUY,      //  
         SymInfo.Name(),      //  
         1,                   // 
         SymInfo.Ask(),       //  
         LotMargin            //     
         )) Print("OrderCalcMargin Error!  GetLastError = ",GetLastError());
     }
   else if(in<-0.000001)
     {
      if(!OrderCalcMargin(
         ORDER_TYPE_SELL,     //  
         SymInfo.Name(),      //  
         1,                   // 
         SymInfo.Bid(),       //  
         LotMargin            //     
         )) Print("OrderCalcMargin Error!  GetLastError = ",GetLastError());
     }
   else return 0;
//   Print(LotMargin,"    //     ");
   double out=(in*AccInfo.Equity()/100)/LotMargin;
//   Print(out,"  //out");
   return out;
  }
//+------------------------------------------------------------------+
